/*
 * ConfigDialog.java
 *
 * Created on 2008/05/24, 6:33
 */

package p4uclient;

import java.awt.event.KeyEvent;

/**
 * 設定ダイアログ
 * @author tondol
 */
public class OptionBox extends javax.swing.JDialog {
    static private OptionBox instance = null;
    
    /** Creates new form ConfigDialog */
    private OptionBox(java.awt.Frame parent) {
        super(parent, true);
        initComponents();
    }
    
    /**
     * 設定ダイアログを表示
     */
    static public void showOptionBox() {
        if (instance == null) {
            instance = new OptionBox(MainApp.window);
        }
        instance.resetComponents();
        instance.setVisible(true);
    }
    
    /**
     * 設定ダイアログの内容を反映
     */
    private void saveOptionBox() {
        MainApp.option.host = txtHost.getText();
        MainApp.option.port = Integer.parseInt(txtPort.getText());
        MainApp.option.listen = Integer.parseInt(txtListen.getText());
        MainApp.option.updir = txtUpDir.getText();
        MainApp.option.downdir = txtDownDir.getText();
    }
    
    /**
     * 各コンポーネントをリセット
     */
    private void resetComponents() {
        txtHost.setText(MainApp.option.host);
        txtPort.setText(String.valueOf(MainApp.option.port));
        txtListen.setText(String.valueOf(MainApp.option.listen));
        txtUpDir.setText(MainApp.option.updir);
        txtDownDir.setText(MainApp.option.downdir);
        btnApply.requestFocus();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        btCancel = new javax.swing.JButton();
        btnApply = new javax.swing.JButton();
        mainPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        txtHost = new javax.swing.JTextField();
        txtPort = new javax.swing.JTextField();
        txtListen = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        txtUpDir = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        txtDownDir = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("P4UClient - 設定");

        btCancel.setText("キャンセル");
        btCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonActions(evt);
            }
        });

        btnApply.setText("適用");
        btnApply.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonActions(evt);
            }
        });

        mainPanel.setLayout(new java.awt.GridBagLayout());

        jLabel1.setText("接続ホスト");
        mainPanel.add(jLabel1, new java.awt.GridBagConstraints());

        jLabel2.setText("接続ポート");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        mainPanel.add(jLabel2, gridBagConstraints);

        jLabel3.setText("待受ポート");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        mainPanel.add(jLabel3, gridBagConstraints);

        txtHost.setFont(txtHost.getFont().deriveFont(txtHost.getFont().getSize()+2f));
        txtHost.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                selectTextAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mainPanel.add(txtHost, gridBagConstraints);

        txtPort.setFont(txtPort.getFont().deriveFont(txtPort.getFont().getSize()+2f));
        txtPort.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                selectTextAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mainPanel.add(txtPort, gridBagConstraints);

        txtListen.setFont(txtListen.getFont().deriveFont(txtListen.getFont().getSize()+2f));
        txtListen.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                selectTextAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mainPanel.add(txtListen, gridBagConstraints);

        jLabel4.setText("送信フォルダ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        mainPanel.add(jLabel4, gridBagConstraints);

        txtUpDir.setFont(txtUpDir.getFont().deriveFont(txtUpDir.getFont().getSize()+2f));
        txtUpDir.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                selectTextAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mainPanel.add(txtUpDir, gridBagConstraints);

        jLabel5.setText("受信フォルダ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        mainPanel.add(jLabel5, gridBagConstraints);

        txtDownDir.setFont(txtDownDir.getFont().deriveFont(txtDownDir.getFont().getSize()+2f));
        txtDownDir.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                selectTextAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mainPanel.add(txtDownDir, gridBagConstraints);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mainPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 623, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(423, Short.MAX_VALUE)
                .addComponent(btnApply)
                .addGap(18, 18, 18)
                .addComponent(btCancel)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(mainPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btCancel)
                    .addComponent(btnApply))
                .addContainerGap())
        );

        pack();
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        java.awt.Dimension dialogSize = getSize();
        setLocation((screenSize.width-dialogSize.width)/2,(screenSize.height-dialogSize.height)/2);
    }// </editor-fold>//GEN-END:initComponents

    private void buttonActions(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonActions
        String action = evt.getActionCommand();
        if (action.equals("適用")) {
            saveOptionBox();
            setVisible(false);
        } else if (action.equals("キャンセル")) {
            setVisible(false);
        }
}//GEN-LAST:event_buttonActions

    private void selectTextAction(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_selectTextAction
        javax.swing.JTextField textBox = (javax.swing.JTextField)evt.getSource();
        textBox.selectAll();
    }//GEN-LAST:event_selectTextAction

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btCancel;
    private javax.swing.JButton btnApply;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JTextField txtDownDir;
    private javax.swing.JTextField txtHost;
    private javax.swing.JTextField txtListen;
    private javax.swing.JTextField txtPort;
    private javax.swing.JTextField txtUpDir;
    // End of variables declaration//GEN-END:variables
    
}
